/* ttt.c - client-server tic-tac-toe game
 *
 * Copyright © 2005 Carl Worth
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Author: Carl Worth <cworth@cworth.org>
 */

#ifndef _TTT_BOARD_H_
#define _TTT_BOARD_H_

#include "ttt.h"
#include "ttt-error.h"

#define TTT_BOARD_MAX_CELLS 9

typedef enum {
    TTT_CELL_EMPTY = '_',
    TTT_CELL_X     = 'X',
    TTT_CELL_O     = 'O'
} ttt_cell_t;

typedef struct _ttt_board {
    ttt_cell_t cells[TTT_BOARD_MAX_CELLS];
    ttt_cell_t current_player;
} ttt_board_t;

void
ttt_board_init (ttt_board_t *board);

void
ttt_board_init_from_string (ttt_board_t *board,
			    const char  *s);

char *
ttt_board_to_string (ttt_board_t *board);

void
ttt_board_write (ttt_board_t *board, FILE *file);

ttt_error_t
ttt_board_make_move (ttt_board_t *board, int move);

ttt_cell_t
ttt_board_is_won (ttt_board_t *board);

#endif


